/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-21 17:18
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, K;

void solve(){
    // Code goes here ...
    cin >> N >> K;
    vector<ll> fruit(N), height(N);

    R(i, N) cin >> fruit[i];
    R(i, N) cin >> height[i];

    vector<ll> prefix_fruit(N);
    prefix_fruit[0] = fruit[0];
    F(i, 1, N) prefix_fruit[i] = prefix_fruit[i - 1] + fruit[i];
    
    vector<int> group(N);
    int id = 1;
    group[0] = id;
    F(i, 1, N) group[i] = group[i - 1] + (height[i - 1] % height[i] == 0 ? 0 : 1);

    /* R(i, N) cout << group[i] << " "; cout << endl; */

    ll l = 0, r = 0, res = 0;
    R(r, N){
        if(group[r] != group[l]) l = r;
        while(prefix_fruit[r] - (l == 0 ? 0 : prefix_fruit[l - 1]) > K) l++;
        ckmax(res, r-l+1);
    }

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
